//+------------------------------------------------------------------+
//|                                                  Custom MACD.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property  copyright "Copyright  2004, MetaQuotes Software Corp."
#property  link      "http://www.metaquotes.net/"
//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 10
#property  indicator_color1  Yellow
#property  indicator_color2  Red
#property  indicator_color3  Blue
#property  indicator_color4  Green 
#property  indicator_color5  Blue 
#property  indicator_color6  Red 
#property  indicator_width1  1
#property  indicator_width2  1
#property  indicator_width3  1
//---- indicator parameters
extern int FastEMA=12;
extern int SlowEMA=26;
extern int SignalSMA=9;
//---- indicator buffers
double     MacdBuffer[];
double     F_upper[];
double     F_lower[];
double     L_Close0[];
double     L_Close1[];
double     L_CloseDelta[];
extern double delta =0.0001;

int m=0 ,n;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(2,DRAW_ARROW);
     SetIndexStyle(3,DRAW_LINE);
//   SetIndexDrawBegin(1,SignalSMA);
//   IndicatorDigits(Digits+1);
//---- indicator buffers mapping
   SetIndexBuffer(0,MacdBuffer);
//   SetIndexBuffer(0,L_Close0);//L_Close0[]
   SetIndexBuffer(1,F_upper);
   SetIndexBuffer(2,F_lower);
   SetIndexBuffer(3,L_CloseDelta);
//---- name for DataWindow and indicator subwindow label
//   IndicatorShortName("MACD("+FastEMA+","+SlowEMA+","+SignalSMA+")");
//   SetIndexLabel(0,"MACD");
//   SetIndexLabel(1,"Signal");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//| Moving Averages Convergence/Divergence                           |
//+------------------------------------------------------------------+
int start()
  {
   int limit; int Fractal;
   int counted_bars=IndicatorCounted();
//---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
      
   limit=Bars-counted_bars;

//   Alert ("limit = ", limit);
//m=0;
//---- macd counted in the 1-st buffer
   for(int i=0; i<limit; i++)

{    

MacdBuffer[i]=iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i)-iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

L_Close0[i]=1.37-Close[i];

//F_upper[i] =iMA(NULL,0,FastEMA,0,MODE_EMA,PRICE_CLOSE,i);

//F_lower[i] = iMA(NULL,0,SlowEMA,0,MODE_EMA,PRICE_CLOSE,i);

//---- signal line counted in the 2-nd buffer
 //  int j=-2; j<=2; j++)
//           {
   
 //  Alert ("limit = ", MacdBuffer[i]-MacdBuffer[i+2] );
   
//   if (F_upper[i] > F_lower[i] && F_upper[i-2] < F_lower[i-2]) MacdBuffer[i-2] =F_upper[i-2];
    
//    if (F_upper[i] < F_lower[i] && F_upper[i-2] > F_lower[i-2] ) MacdBuffer[i-2] =F_lower[i-2];



   if (MacdBuffer[i-2]>delta)    
      if (MacdBuffer[i-2]-MacdBuffer[i-4] > 0)
        if (MacdBuffer[i-2]-MacdBuffer[i-3] > 0)
           if (MacdBuffer[i-2]-MacdBuffer[i-1] > 0)
             if (MacdBuffer[i-2]-MacdBuffer[i] > 0) 
             
           {  F_upper[i-2]=L_Close0[i-2]; m=i-2; }
  
   if (MacdBuffer[i-2]<-1*delta)
       if (MacdBuffer[i-2]-MacdBuffer[i-4] < 0)
        if (MacdBuffer[i-2]-MacdBuffer[i-3] < 0)
          if (MacdBuffer[i-2]-MacdBuffer[i-1] <  0)
            if (MacdBuffer[i-2]-MacdBuffer[i] < 0) 
            
         {   F_lower[i-2]=L_Close0[i-2]; m=i-2; }
      
      
   //    if (MacdBuffer[i-4]-MacdBuffer[i-2] < 0)
   //     if (MacdBuffer[i-3]-MacdBuffer[i-2] < 0)
   //        if (MacdBuffer[i-1]-MacdBuffer[i-2] < 0)
   //          if (MacdBuffer[i]-MacdBuffer[i-2] < 0) SignalBuffer[i-2]= MacdBuffer[i-2];   
                
//---- done*/


L_CloseDelta[i]=Close[i]- Close[m];


}
   return(0);
  }
//+------------------------------------------------------------------+